<id>
Avatars Upload
</id>

<version>
1.1
</version>

<mod info>
For YaBB 1 Gold - SP 1.1

!!! Before installing this version please uninstall previous version !!!
!!! Important !!! From version 1.1 this mod can be not compatible with ImgSize mod .

Changes in v1.1  (20/11/2002)
- Now it possible to upload pictures with dimensions more than size limited by forum admin. Such images will be resized in 
forum with saving there's aspect ratio.

Changes in v0.3  (20/11/2002)
- Fixed bug with recognizing dimensions of uploaded user pic.

Changes in v0.2  (30/09/2002)
- Fixed error with bad saving settings
- Now all uploaded avatars pics saved with name of uploaded them user.

Thanks to Dave Baughman for help in bug hunting and ideas ;o)

About mod:
Allow users to upload avatar pics to forum.
Admins can set limits on size and dimensions of uploaded pics.
Admins can permit or deny to upload pics.
Pics can be in gif, jpg and png formats.
Pics are uploaded in a special subdirectory created in avatars directory and can be used only by user who uploaded them. After uploading a new picture the old one is erased. 

Installing:
Uninstal previously installed versions of this mod.

After setting this mod an admin needs to configure its properties in "Admin/Forum Preferences and Settings" section.

All errors and request please send to my email: ryoko@tut.by
2002. Ryoko[Anibel] 
</mod info>

<author>
Ryoko [Anibel]
</author>

<homepage>
mailto:ryoko@tut.by
</homepage>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
	my $query = new CGI;
</search for>

<replace>
	$query = new CGI; #Ryoko upload avatars mod changed
</replace>

<search for>
1;
</search for>

<add before>
# Ryoko upload avatars mod begin
sub getsize {
        my ($type, $buf)=@_; my ($x, $y, $r);
        if ($type=~/image\/pjpeg/){
           for $r ($buf=~/\377[\300-\311]..\010(....)/g){
              ($x,$y)=unpack('nn',$r);
           }
           return ($x, $y) if ($x and $y); 
        }elsif($type=~/image\/gif/){
           if ($buf=~/^GIF8[79]a(....)/){
              my ($x,$y)=unpack('vv',$1);
              return ($x, $y);
           }
        }elsif($type=~/image\/x-png/){
           if ($buf=~/IHDR(.{8})/){
              my ($x,$y)=unpack('NN',$1);
              return ($x, $y);
           }
        }
        return (9999,9999);
}
# Ryoko upload avatars mod end

</add before>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
<form action="$cgi;action=profile2" method="POST" name="creator">
</search for>

<replace>
<form action="$cgi;action=profile2" method="POST" name="creator" enctype="multipart/form-data"> <!-- #Ryoko upload avatars mod changed -->
</replace>

<search for>
		$images = "";
		foreach $line (sort @contents){

</search for>

<replace>
		$images = "";
# Ryoko upload avatars mod  begin
		if ($can_upload_pic && $memsettings[13] =~ m|$personal_dir/(.+)|i) {				
			   $images .= qq~<option value="$memsettings[13]" selected>$1\n~;
		}
# Ryoko upload avatars mod end
		foreach $line (sort @contents){

</replace>

<search for>
      </tr><tr>
	<td width="320"><font size="2"><B>$txt{'475'}</B></font></td>
	<td><input type="checkbox" name="userpicpersonalcheck"$checked>
	<input type="text" name="userpicpersonal" size="45" value="$tmp"></td>
      </tr>
~;
</search for>

<replace>
<!-- #Ryoko upload avatars mod begin -->
      </tr><tr>
	<td width="320"><font size="2"><B>$picupl{'01'}</B></font></td>
	<td><input type="radio" name="type_userpic" value="url" $checked> <!-- #Ryoko-->
	<input type="text" name="userpicpersonal" size="46" value="$tmp"></td>
      </tr>
~;
	  if ($can_upload_pic){  
	     $yymain .= qq~  
	  <tr>
	<td width="320"><font size="2"><B>$picupl{'02'}</B></font></td>
	<td><input type="radio" name="type_userpic" value="file">
	<input type="file" name="pic_file" size="35" value="$tmp"></td>
	  </tr>
~;
  	  }
<!-- # Ryoko upload avatars mod end -->
</replace>

<search for>
	if( $member{'userpicpersonalcheck'} && ( $member{'userpicpersonal'} =~ m/\.gif\Z/i || $member{'userpicpersonal'} =~ m/\.jpg\Z/i || $member{'userpicpersonal'} =~ m/\.jpeg\Z/i || $member{'userpicpersonal'} =~ m/\.png\Z/i ) ) {
		$member{'userpic'} = $member{'userpicpersonal'};
	}
</search for>

<replace>
#Ryoko upload avatars mod begin
	if($can_upload_pic && ($member{type_userpic} eq 'file') && (my $flhn=$query->param('pic_file'))){
			 local *info=$query->uploadInfo($flhn);				  
			 my $type = $info{'Content-Type'};
			 if ($type!~m#image/(gif|pjpeg|jpeg|png|x-png)#){
			 	&fatal_error("$picupl{'03'} $type.");
			 } 		
			 if ($flhn=~/([^\/\\]+)\.(\w+)$/){ 
			 	my ($fn, $fe, $fname)=(lc($member{'username'}),lc($2)); 
				for my $ext ('gif', 'jpg', 'png', 'jpeg'){
					next if $ext eq $fe;
					$fname="$facesdir/$personal_dir/$fn.$ext";
					if (-e $fname){
					   unlink($fname) || &fatal_error("$picupl{'10'} '$fname': $!");
					}
				}
				$fname="$personal_dir/$fn.$fe";
			 	if (open (FH, ">$facesdir/$fname")){
			 	   binmode FH;
				   my ($buffer, $fs, $sz, $imgx, $imgy); 
                            		   if ($fs=read($flhn,$buffer,$max_upload_size+10)){ 
                                   		      ($imgy, $imgx)=getsize($type,$buffer) unless $imgx;
                                   		      print FH $buffer;
                            		   }
			 	   #$member{'usertext'}="$imgx x $imgy";
				   close FH; 
				   chmod(0666, "$facesdir/$fname");
				   if ($max_upload_size && $fs > $max_upload_size) {
				   	  unlink "$facesdir/$fname";
					  &fatal_error("$picupl{'04'}" );
				   }
                           if (($userpic_width && $imgx > $userpic_width) || ($userpic_height && $imgy > $userpic_height)) {
		     if ($can_resize_pic) {
		    	my $kx=$imgx/$userpic_width;
			my $ky=$imgy/$userpic_height;
			my $k=($kx > $ky)?$kx:$ky;
			$kx=int($imgx/$k);
			$ky=int($imgy/$k);
                              	$member{'userpic'} = "$fname?$kx:$ky";
		     }else{
                             	unlink "$facesdir/$fname";
                             	&fatal_error("$picupl{'05'} $imgx x $imgy px.");
		     }
                           }else{
                              $member{'userpic'} = "$fname";
				   }	 
				}   
			
			 }
			 close $flhn;
	}elsif( $member{type_userpic} eq 'url' && ( $member{'userpicpersonal'} =~ m/\.(gif|jpg|jpeg|png)\Z/i ) ) {
		$member{'userpic'} = $member{'userpicpersonal'};
	}
#Ryoko upload avatars mod end
</replace>

<search for>
	if ($memsettings[13] =~ /^\http:\/\// ) {
		if ($userpic_width ne 0) { $tmp_width = "width=$userpic_width"; } else { $tmp_width=""; }
		if ($userpic_height ne 0) { $tmp_height = "height=$userpic_height"; } else { $tmp_height=""; }
		$pic = qq~<a href="$memsettings[13]" target="_blank" onClick="window.fopen('$memsettings[13]', 'ppic$INFO{username}', 'resizable,width=200,height=200'); return false;">~;
		$pic = qq~<img src="$memsettings[13]" $tmp_width $tmp_height border=0></a>~;
	}
	else {
		$pic = qq~<a href="$facesurl/$memsettings[13]" target="_blank" onClick="window.fopen('$facesurl/$memsettings[13]', 'ppic$INFO{username}', 'resizable,width=200,height=200'); return false;">~;
		$pic = qq~<img src="$facesurl/$memsettings[13]" border=0></a>~;
	}

</search for>

<replace>
#Ryoko upload pics begin		
		my($tmp_width, $tmp_height);
        if ($memsettings[13] =~ /^\http:\/\// ) {
             if ($userpic_width ne 0) { $tmp_width = "width=$userpic_width"; }
             if ($userpic_height ne 0) { $tmp_height = "height=$userpic_height"; }
        	 $pic = qq~<img src="$memsettings[13]" $tmp_width $tmp_height border=0></a>~;
        }
        else {
		    if ($memsettings[13] =~ s/\?(\d+)\:(\d+)$//) {
			   $tmp_width = "width=$1";
			   $tmp_height = "height=$2";   
			}
        	$pic = qq~<img src="$facesurl/$memsettings[13]" $tmp_width $tmp_height border=0></a>~;
        }
#Ryoko upload pics begin

</replace>

<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
	my($snfchecked, $fls1, $fls2, $fls3, $utfchecked, $truncchecked, $mts1, $mts2, $mts3, $tsl6, $tsl5, $tsl4, $tsl3, $tsl2, $tsl1);
</search for>

<add after>
	my($cupchecked, $cresizepic); #Ryoko upload avatars mod
</add after>

<search for>
	if ($timeselected == 6) { $tsl6 = " selected" } elsif ($timeselected == 5) { $tsl5 = " selected" } elsif ($timeselected == 4) { $tsl4 = " selected" } elsif ($timeselected == 3) { $tsl3 = " selected" } elsif ($timeselected == 2) { $tsl2 = " selected" } else { $tsl1 = " selected" }
</search for>

<add after>
	if ($can_upload_pic) {$cupchecked = " checked"};  #Ryoko upload avatars mod 
	if ($can_resize_pic) {$cresizepic = " checked"};  #Ryoko upload avatars mod 
	if (!$personal_dir) {$personal_dir = "personal"}; #Ryoko upload avatars mod 
	if (!$max_upload_size) {$max_upload_size = 20480};#Ryoko upload avatars mod 
</add after>

<search for>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="userpic_limits" size="45" value="$userpic_limits"></td>
</search for>

<add after>
<!-- #Ryoko upload avatars mod begin --> 
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$picupl{'06'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="can_upload_pic" $cupchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$picupl{'11'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="can_resize_pic" $cresizepic></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$picupl{'08'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="max_upload_size" size="45" value="$max_upload_size"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$picupl{'07'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="personal_dir" size="45" value="$personal_dir"></td>
<!-- #Ryoko upload avatars mod end --> 

</add after>

<search for>
	my @onoff = qw/
		allowpics showyabbcbutt showbdescrip maintenance guestaccess insert_original enable_ubbc enable_news enable_guestposting enable_notification showlatestmember showrecentbar showmarkread showmodify showuserpic showusertext showgenderimage shownewsfader MenuType curposlinks profilebutton autolinkurls emailpassword RegAgree emailwelcome allow_hide_email usetempfile faketruncation emailnewpass/;
</search for>

<add after>
	push(@onoff, "can_upload_pic"); #Ryoko upload avatars mod 
	push(@onoff, "can_resize_pic"); #Ryoko upload avatars mod 


</add after>

<search for>
	$userpic_limits =~ s/\"/\'/g;
</search for>

<add after>
#Ryoko upload avatars mod begin	
	$can_upload_pic = $FORM{'can_upload_pic'} || '0';
	$can_resize_pic = $FORM{'can_resize_pic'} || '0';
	$personal_dir = $FORM{'personal_dir'} || 'personal';
	$max_upload_size = $FORM{'max_upload_size'} || 20480;
	if (!(-d "$facesdir/$personal_dir")){
	   mkdir("$facesdir/$personal_dir", 0777) || &fatal_error("$picupl{'09'} $!");
	}
#Ryoko upload avatars mod end	
</add after>

<search for>
\$timeout = $timeout;					# Minimum time between 2 postings from the same IP

</search for>

<add after>
#Ryoko upload avatars mod 

\$can_upload_pic = $can_upload_pic;		# Allow to upload avatars pics
\$can_resize_pic = $can_resize_pic;		# Allow to upload avatars pics
\$personal_dir = "$personal_dir"; 		# Subdirectory in avtars directory where to place uploaded pictures
\$max_upload_size = "$max_upload_size";   # Size limit of uploaded pics.
</add after>

<edit file>
english.lng
</edit file>

<search for>
$txt{'796'} = "Your Instant Messages:";
</search for>

<add after>
#Ryoko upload avatars mod strings
$picupl{'01'} = "URL to my pic:";
$picupl{'02'} = "Upload my pic:";
$picupl{'03'} = "Wrong file type. Only files in gif, jpg and png formats are accepted. Your file is recognized as:";
$picupl{'04'} = "Size of uploaded pic exceeds the limit of $max_upload_size bytes.";
$picupl{'05'} = "Dimensions of uploaded pic exceed the limit of $userpic_width x $userpic_height px.<br>Your pic dimensions are recognized as:";
$picupl{'06'} = "Allow to upload users pics";
$picupl{'07'} = "Uploaded userpics Directory";
$picupl{'08'} = "Userpic size (0 = disable limit)";
$picupl{'09'} = "Can't create directory '$facedir/$personal_dir':";
$picupl{'10'} = "Can't delete file ";
$picupl{'11'} = "Allow to upload pics with size more than limits<br>On board pics will be resized";

</add after>

<edit file>
Sources/Load.pl
</edit file>

<search for>
		$userprofile{$user}->[13] = $userprofile{$user}->[13] =~ m~\A[\s\n]*http://~i ? qq~<br><img src="$userprofile{$user}->[13]"$userpic_tmpwidth$userpic_tmpheight border="0" alt=""><br><br>~ : qq~<br><img src="$facesurl/$userprofile{$user}->[13]" border="0" alt=""><br>~;
</search for>

<replace>
#Ryoko upload pics begin				
	   		  	if ($userprofile{$user}->[13] =~ m~\A[\s\n]*http://~i){
                   $userprofile{$user}->[13] = qq~<br><img src="$userprofile{$user}->[13]"$userpic_tmpwidth$userpic_tmpheight border="0" alt=""><br><br>~;
				}else{
				   my $isize=($userprofile{$user}->[13] =~ s/\?(\d+)\:(\d+)$//)?"width=$1 height=$2":'';   
				   $userprofile{$user}->[13] = qq~<br><img src="$facesurl/$userprofile{$user}->[13]" border="0" $isize alt=""><br>~;
				}
#Ryoko upload pics end

</replace>